#  CMake configure file for alps-hdf5. Defines:
#  alps-hdf5_FOUND        - System has alps-hdf5
#  alps-hdf5_LIBRARIES    - The alps-hdf5 libraries (external targets)
#  alps-hdf5_HAS_MPI      - The alps-hdf5 is compiled with MPI enabled

# FIXME: is not affected by alps-hdf5_LIBRARY

foreach(dep_ alps-utilities)
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-hdf5.cmake)

set(alps-hdf5_HAS_MPI TRUE)
set(alps-hdf5_LIBRARIES alps::alps-hdf5)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-hdf5 DEFAULT_MSG alps-hdf5_LIBRARIES)
